﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Spring.NET Web Framework Quick Start Guide</title>
</head>
<body>
    <h2>Welcome to Spring.NET Web Framework Quick Start Guide</h2>
    <div>
    <p>
    This sample application provides a number of small Quick Starts
    that demonstrate various features of the Spring.NET Web Framework.
    </p>
    <p>
    Spring.NET Web Framework is an extension to ASP.NET that adds many
    powerful features, such as Dependency Injection for web pages and
    controls, bi-directional data binding, localization support, etc.
    </p>
    <p>
    It also integrates extremely well with Spring.NET Data Validation Framework
    and allows you to declaratively configure very complex and sophisticated
    data validation rules.
    </p>
    <p>
    Once you become acquainted with all the individual features of Spring.NET 
    Web Framework by studying this application, you should take a look at SpringAir
    sample application for a more integrated view, in order to see how many of these
    features are combined into an application.
    </p>
    <h2>Feature Categories</h2>
    <p>
    Following sections provide a brief overview of different Spring.NET Web Framework
    feature catagories. Within each category you will find small examples that clearly 
    demonstrate various features within that category, which will be very beneficial 
    to everyone who prefers to learn by example.
    </p>
    <h3><a href="DI/Default.aspx">Dependency Injection</a></h3>
    <p>
    Samples in this category show you how to inject dependencies into your web pages
    and controls using Spring.NET DI Container. You will learn about different 
    configuration options, basic steps you need to take in order to enable DI in your
    pages, and then move on to more complex examples that will show you how to separate
    your application into components using hierarchical web contexts.
    </p>
    <h3><a href="DataBinding/Default.aspx">Bi-directional Data Binding</a></h3>
    <p>
    By studying samples in this category, you will learn how to declaratively define
    data binding rules that will save you a ton of time and many lines of code when
    developing Spring.NET-powered web applications. We will start with basic examples 
    and then move on to using more advanced features, such as type conversion, formatting,
    automatic validation and binding to complex iterative structures.
    </p>
    <h3>Localization</h3>
    <p>
    In this section you will learn how to properly localize your web applications. We will
    start with very simple automatic localization, and then move on to demonstrate different
    user culture management strategies, explicit localization options, and localization of
    images within your application.
    </p>
    <h3>Data Validation</h3>
    <p>
    Spring.NET includes a very powerful, generic Data Validation Framework. This framework is 
    very tightly integrated with Spring.NET Web Framework, and it allows you to configure 
    sophisticated validation rules and execute them as necessary. In this section we will
    start with a Hello World! validation example and then move on to show you how you can 
    compose advanced validation rules that leverage validation groups, conditional validation,
    validator composition, as well as how to create and use your custom validators.
    </p>
    <h3><a href="Navigation/Default.aspx">Navigation Flow</a></h3>
    <p>
    Demoes configurable navigation flow capabilities.
    </p>
    </div>
</body>
</html>
